exercise_04_15: exercise_04_15.o | .gitignore
	g++ $^ -o $@ 
exercise_04_15.ii: exercise_04_15.cpp
	g++ -E $^ -o $@
exercise_04_15.s: exercise_04_15.ii
	g++ -S $^ -o $@
exercise_04_15.o: exercise_04_15.s
	g++ -c $^ -o $@
.gitignore:
	echo "exercise_04_15" > $@
clean:
	rm *.ii *.s *.o exercise_04_15 .gitignore
test1: exercise_04_15 
	./exercise_04_15 < test1.in > test1.out
	diff test1.out test1.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_04_15.ii exercise_04_15.s
.SECONDARY: exercise_04_15.ii exercise_04_15.s

dbg: debug/exercise_04_15 
debug/exercise_04_15: debug/exercise_04_15.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@
debug/exercise_04_15.o: debug/exercise_04_15.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@
debug/exercise_04_15.s: debug/exercise_04_15.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@
debug/exercise_04_15.ii: exercise_04_15.cpp
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@
debug/exercise_04-15.ii: | debug
debug:
	mkdir -p debug
